from . import OAuth2


class GoogleInfo:
    @property
    def name(self):
        return "google"

    @property
    def request_token_params(self):
        return {"scope": "email"}

    @property
    def base_url(self):
        return "https://www.googleapis.com/oauth2/v1/"

    @property
    def access_token_method(self):
        return "POST"

    @property
    def access_token_url(self):
        return "https://accounts.google.com/o/oauth2/token"

    @property
    def authorize_url(self):
        return "https://accounts.google.com/o/oauth2/auth"

    @property
    def user_info_key(self):
        return "userinfo"

    def process_user_info(self, user):
        return {
            "source": {
                "name": "google-oauth2",
                "version": 1
            },
            "id": user["id"],
            "name": user["name"],
            "email": user["email"],
            "picture": user["picture"],
        }


class GoogleOAuth2(OAuth2):
    def __init__(
            self, client_id, client_secret, return_uri="/"):
        super().__init__(
            GoogleInfo(), client_id, client_secret, return_uri)
